/***********************************************************************************************
   -  ATmega16/16L/32A/32L    (       3  )
  - 8,000000 MHz
**********************************************************************************************/
#define   VER                1004      //    10-04-12 _____ 1.08 O-LED
//*********************************************************************************************/ 
//      
#define   ATMEGA16          1
#define   ATMEGA32          0
//*********************************************************************************************/ 
//     
#define   OK                1         //    ""  (  5, 2, 7, 1, 12, 8, 14, 9  )  
#define   OA                0        //    ""  (  5, 2, 7, 1, 12, 8, 14, 9   )  
//*********************************************************************************************/
//  FONT      ( 0  6)
#define   FONT              5         //   
//*********************************************************************************************/
//**********************************************************************************************/
#define   RET_CLOCK        120      //        ( ) 
//*********************************************************************************************/ 

# if ATMEGA16
#include <mega16.h>
# endif 
# if ATMEGA32
#include <mega32.h>
# endif
 
#include <1wire.h>
#include <ds18b20_.h>
#include <delay.h>

#define   BUT_OK      button==1
#define   BUT_STEP    button==2
#define   POWER       power
#define   ON          1
#define   OFF         0
//*********************************************************************************************/

bit                 mig, mig_vrem, flg_min=0,  sek0=0, bud_flg=0, budilnik=0, sek_ind=1, but_flg=0,  zv_kn=0,  zv_chs=1, but_on=0, line=0, power=1, temp5=0, flg_adch, flg_ds18b20;
unsigned char       meny=10, sek=0, chislo=10, mesec=04, god=12, den_nedeli, td10=0, tu10=1,  bud_temp, stroka, button, but_pause=0,  z, z1, bud, temp, temp1=0, temp2=0, t, flg_korr=1, speed=28, foto_r=0,
                  
                    ekran            [24],         //   
                    beg_info         [99],         //      
                    rom_code         [2][9],       //      DS18B20
                    //column_ram       [24],//={16,22,23,11,13,8,14,15,21,19,1,7,6,0,5,3,20,18,17,12,10,9,4,2},         //        
                    budilnik_Install [9],          //   
                    budilnik_Interval[9];          //     
unsigned   int      budilnik_time    [9];          //    
const unsigned char
        budilnik_txt          []= {11,29,14,18,21,38,23,18,20,42,255},       //  ""
        korekt_txt            []= {20,24,26,26,15,20,32,18,41,42,42,255},    //  ""
        nastroiki_txt         []= {29,27,28,10,23,24,12,20,18,42,255},       //  ""
        den_txt               []= {14,15,23,38,255},                         //  ""
        data_txt              []= {14,10,28,10,255},                         //  ""
        god_txt               []= {13,24,14,255},                            //  ""
        nastr_stroki_txt      []= {23,10,27,28,26,24,19,20,10,42,255},       //  ""
        speed_txt             []= {27,20,24,26,24,27,28,38,42,11,15,13,29,35,15,19,42,27,28,26,24,20,18,42,255},  //  "  " 
        perenazna_datchik     []= {25,15,26,15,23,10,16,23,10,33,15,23,18,15,42,14,10,28,33,18,20,24,12,42,255},  //  " "
        budilnik_Interval_txt []= {14,21,18,28,15,21,38,23,24,27,28,38,42,27,18,13,23,10,21,10,42,255},              //  " "
        den_nedeli_txt  [7][12]= {{25,24,23,15,14,15,21,38,23,18,20,255},   //      //    
                                 {12,28,24,26,23,18,20,255},                //          //
                                 {27,26,15,14,10,255},                      //            //
                                 {33,15,28,12,15,26,13,255},                //          //
                                 {25,41,28,23,18,32,10,255},                //          //
                                 {27,29,11,11,24,28,10,255},                //          //
                                 {12,24,27,20,26,15,27,15,23,38,15,255}},   //      //                                    
        den_nedeli_letter[7][2]= {{25,23},                                  //               //     
                                 {12,28},                                   //               //
                                 {27,26},                                   //               //
                                 {33,28},                                   //               //
                                 {25,28},                                   //               //
                                 {27,11},                                   //               //
                                 {12,27}},                                  //               //            
        name_mesec_txt  [12][9]= {{41,23,12,10,26,41,255},                  // 
                                 {30,15,12,26,10,21,41,255},                // 
                                 {22,10,26,28,10,255},                      // 
                                 {10,25,26,15,21,41,255},                   // 
                                 {22,10,41,255},                            // 
                                 {18,40,23,41,255},                         // 
                                 {18,40,21,41,255},                         // 
                                 {10,12,13,29,27,28,10,255},                // 
                                 {27,15,23,28,41,11,26,41,255},             // 
                                 {24,20,28,41,11,26,41,255},                // 
                                 {23,24,41,11,26,41,255},                   // 
                                 {14,15,20,10,11,26,41,255}};               //                          
flash  const unsigned char  simvol [][5]=     
    {
    # if FONT==0    //    0
    { 0x3E, 0x51, 0x49, 0x45, 0x3E },  // 0
    { 0x00, 0x42, 0x7F, 0x40, 0x00 },  // 1
    { 0x42, 0x61, 0x51, 0x49, 0x46 },  // 2
    { 0x21, 0x41, 0x45, 0x4B, 0x31 },  // 3
    { 0x18, 0x14, 0x12, 0x7F, 0x10 },  // 4
    { 0x27, 0x45, 0x45, 0x45, 0x39 },  // 5
    { 0x3C, 0x4A, 0x49, 0x49, 0x30 },  // 6
    { 0x01, 0x71, 0x09, 0x05, 0x03 },  // 7
    { 0x36, 0x49, 0x49, 0x49, 0x36 },  // 8
    { 0x06, 0x49, 0x49, 0x29, 0x1E },  // 9
    # endif
    # if FONT==1    //    1
    { 0x7F, 0x7F, 0x41, 0x7F, 0x7F },
    { 0x00, 0x00, 0x7F, 0x7F, 0x00 },
    { 0x61, 0x71, 0x59, 0x4F, 0x47 },
    { 0x41, 0x49, 0x49, 0x7F, 0x7F },
    { 0x1F, 0x1F, 0x10, 0x7F, 0x7F },
    { 0x4F, 0x4F, 0x49, 0x79, 0x79 },
    { 0x7F, 0x7F, 0x49, 0x79, 0x79 },
    { 0x01, 0x71, 0x79, 0x0F, 0x07 },
    { 0x7F, 0x7F, 0x49, 0x7F, 0x7F },
    { 0x5F, 0x5F, 0x51, 0x7F, 0x7F },
    # endif
    # if FONT==2    //    2
    { 0x7F, 0x7F, 0x41, 0x7F, 0x7F },
    { 0x00, 0x01, 0x7F, 0x7F, 0x00 },
    { 0x63, 0x73, 0x59, 0x4F, 0x47 },
    { 0x63, 0x63, 0x49, 0x7F, 0x77 },
    { 0x1F, 0x1F, 0x10, 0x7F, 0x7F },
    { 0x6F, 0x6F, 0x49, 0x79, 0x79 },
    { 0x7F, 0x7F, 0x49, 0x7B, 0x7B },
    { 0x03, 0x73, 0x79, 0x0F, 0x07 },
    { 0x77, 0x7F, 0x49, 0x7F, 0x77 },
    { 0x6F, 0x6F, 0x49, 0x7F, 0x7F },
    # endif
    # if FONT==3    //    3
    { 0x7F, 0x41, 0x41, 0x7F, 0x7F },
    { 0x00, 0x00, 0x7F, 0x7F, 0x00 },
    { 0x61, 0x71, 0x59, 0x4F, 0x47 },
    { 0x41, 0x49, 0x49, 0x7F, 0x7F },
    { 0x1F, 0x10, 0x10, 0x7F, 0x7F },
    { 0x4F, 0x49, 0x49, 0x79, 0x79 },
    { 0x7F, 0x49, 0x49, 0x79, 0x79 },
    { 0x01, 0x01, 0x01, 0x7F, 0x7F },
    { 0x7F, 0x49, 0x49, 0x7F, 0x7F },
    { 0x1F, 0x11, 0x11, 0x7F, 0x7F },
    # endif
    # if FONT==4    //    4
    { 0x7F, 0x41, 0x41, 0x7F, 0x7F },
    { 0x00, 0x01, 0x7F, 0x7F, 0x00 },
    { 0x63, 0x71, 0x59, 0x4F, 0x47 },
    { 0x63, 0x41, 0x49, 0x7F, 0x7F },
    { 0x1F, 0x10, 0x10, 0x7F, 0x7F },
    { 0x6F, 0x49, 0x49, 0x79, 0x79 },
    { 0x7F, 0x49, 0x49, 0x7B, 0x7B },
    { 0x03, 0x01, 0x01, 0x7F, 0x7F },
    { 0x7F, 0x49, 0x49, 0x7F, 0x7F },
    { 0x1F, 0x11, 0x11, 0x7F, 0x7F },
    # endif
    # if FONT==5    //    5    
    { 0x3E, 0x7F, 0x41, 0x7F, 0x3E },
    { 0x00, 0x02, 0x7F, 0x7F, 0x00 },
    { 0x62, 0x73, 0x59, 0x4F, 0x46 },
    { 0x22, 0x63, 0x49, 0x7F, 0x36 },
    { 0x18, 0x14, 0x12, 0x7F, 0x7F },
    { 0x2F, 0x6F, 0x45, 0x7D, 0x39 },
    { 0x3E, 0x7F, 0x49, 0x7B, 0x32 },
    { 0x03, 0x73, 0x79, 0x0F, 0x07 },
    { 0x36, 0x7F, 0x49, 0x7F, 0x36 },
    { 0x2E, 0x6F, 0x49, 0x7F, 0x3E },
    # endif
    # if FONT==6    //    6
    { 0x3E, 0x41, 0x41, 0x7F, 0x3E },
    { 0x00, 0x02, 0x7F, 0x7F, 0x00 },
    { 0x62, 0x71, 0x59, 0x4F, 0x46 },
    { 0x22, 0x41, 0x49, 0x7F, 0x36 },
    { 0x18, 0x14, 0x12, 0x7F, 0x7F },
    { 0x2F, 0x45, 0x45, 0x7D, 0x39 },
    { 0x3E, 0x49, 0x49, 0x7B, 0x32 },
    { 0x03, 0x71, 0x79, 0x0F, 0x07 },
    { 0x36, 0x49, 0x49, 0x7F, 0x36 },
    { 0x26, 0x49, 0x49, 0x7F, 0x3E },
    # endif                    
	{ 0x7C, 0x12, 0x12, 0x7C, 0xAA },  //   10
	{ 0x7E, 0x4A, 0x4A, 0x32, 0xAA },  //   11
	{ 0x7E, 0x4A, 0x4A, 0x34, 0xAA },  //   12
	{ 0x7E, 0x02, 0x02, 0xAA, 0x00 },  //   13
	{ 0x60, 0x3C, 0x22, 0x3E, 0x60 },  //   14
	{ 0x7E, 0x4A, 0x4A, 0xAA, 0x00 },  //   15
	{ 0x24, 0x42, 0x4A, 0x34, 0x00 },  //   16
	{ 0x66, 0x18, 0x7E, 0x18, 0x66 },  //   17
	{ 0x7E, 0x10, 0x08, 0x7E, 0xAA },  //   18
	{ 0x7C, 0x11, 0x09, 0x7C, 0xAA },  //   19      
	{ 0x7E, 0x18, 0x24, 0x42, 0xAA },  //   20
	{ 0x78, 0x04, 0x02, 0x7E, 0xAA },  //   21
	{ 0x7E, 0x04, 0x08, 0x04, 0x7E },  //   22
	{ 0x7E, 0x08, 0x08, 0x7E, 0xAA },  //   23
	{ 0x3C, 0x42, 0x42, 0x3C, 0xAA },  //   24
	{ 0x7E, 0x02, 0x02, 0x7E, 0xAA },  //   25
	{ 0x7E, 0x12, 0x12, 0x0C, 0xAA },  //   26
	{ 0x3C, 0x42, 0x42, 0x24, 0xAA },  //   27
	{ 0x02, 0x7E, 0x02, 0xAA, 0x00 },  //   28
	{ 0x4E, 0x50, 0x50, 0x3E, 0xAA },  //   29
	{ 0x0C, 0x12, 0x7E, 0x12, 0x0C },  //   30
	{ 0x66, 0x18, 0x18, 0x66, 0xAA },  //   31      
	{ 0x7E, 0x40, 0x40, 0x7E, 0xC0 },  //   32
	{ 0x0E, 0x10, 0x10, 0x7E, 0xAA },  //   33
	{ 0x7E, 0x40, 0x7E, 0x40, 0x7E },  //   34
	{ 0x7E, 0x40, 0x7E, 0x40, 0xFE },  //   35
	{ 0x02, 0x7E, 0x48, 0x30, 0xAA },  //   36
	{ 0x7E, 0x48, 0x30, 0x00, 0x7E },  //   37
	{ 0x7E, 0x48, 0x30, 0xAA, 0x00 },  //   38
	{ 0x24, 0x42, 0x4A, 0x3C, 0xAA },  //   39
	{ 0x7E, 0x08, 0x3C, 0x42, 0x3C },  //   40
	{ 0x4C, 0x32, 0x12, 0x7E, 0xAA },  //   41
	{ 0x00, 0x00, 0xAA, 0xAA, 0x00 },  //               42
    { 0x40, 0xAA, 0xAA, 0xAA, 0x00 },  //                43
    { 0xAA, 0xAA, 0xAA, 0xAA, 0x00 },  //      44
    { 0x00, 0x00, 0x00, 0x00, 0x00 },  // ""      45
    { 0x08, 0x08, 0x08, 0x08, 0x08 },  //                46
	{ 0x08, 0x08, 0x3E, 0x08, 0x08 },  //                 47
	{ 0x06, 0x09, 0x09, 0x06, 0xAA },  //          48
    { 0x3E, 0x41, 0x41, 0x41, 0x22 },  //  C           49
    { 0x04, 0x3F, 0x44, 0x20, 0xAA },  //  t         50
    { 0x08, 0x08, 0x08, 0xAA, 0x00 },  //       51
    { 0x3F, 0x40, 0x40, 0x3f, 0x00 },  //   V        52
    { 0x40, 0x40, 0x40, 0xAA, 0x00 },  //  _     53
    { 0x80, 0xAA, 0xAA, 0xAA, 0xAA },  //   _       54
    { 0x00, 0x00, 0x00, 0x00, 0x00 },  //               55

    },
    
  
dnei_v_mesc     []= {31,29,31,30,31,30,31,31,30,31,30,31};           //     
unsigned   int          time=720 , Interval , Interval_2, data1, time_meny ;          //     time=720
float                   temperature_temp;
eeprom signed int       korr_den, brigh_up_time, brigh_down_time;
eeprom unsigned char    brigh_up, str=0x1B; //0x18;
static unsigned char    devices, i;
static  signed   int    temperature [12]={10,20,30,40,50,60,70,80,90,100,110,120}; 
eeprom char ds1820_d, ds1820_y;
unsigned char  error_ds18b20[];

//___________________________   _____________________________________ 
signed int abs (signed int x)
{
if (x<0) x=(x*(-1));
return x;
}

//______    (  DANKO c  "" )))  )_________
unsigned char Day_week (void) 
{
unsigned char y, m, myday;

   y = god;
   m = mesec;

   if (m > 2) { m -= 2;       }
   else       { m += 10; y--; }

   myday = ((chislo + y + (y>>2) + ((31 * m) / 12)) % 7);
   
   if (myday)  return myday-1;  else  return  6;
}

//___________________________________________ ___________________________________________
void correkt (void)
{   
        if(korr_den<0) {TCNT2=255+((korr_den%10)*25); sek=59+((korr_den%600)/10);
                           if (sek==60) {sek=0;}
                            time=1439;
                        }    
        else {TCNT2=25*(korr_den%10); sek=((korr_den%600)/10);} 
}  


//____________________________ . (  )________________________________
interrupt [TIM0_COMP] void timer0_comp_isr(void)
{
PORTA=0;     //        
PORTB&=0xFC; //           /---/
PORTC=0;     //           /---/
PORTD=0;     //           /---/
}
        
//________ .          _______________
interrupt [TIM0_OVF] void timer0_ovf_isr(void)
{

//flg_din=1;

        stroka >>= 1;  if (stroka==0)  stroka=0b10000000;    //     
        if (stroka==0b00000001)  PORTB.7= 1;  else  PORTB.7=0;
              
        PORTB.6=1;    //
        
        //*********** ***************************
        if(flg_adch)                    //       
        {
        flg_adch=0;                     //  ""  
        PORTA.7=0; DDRA.7=0;            //  .7   ,         , 
        ADCSRA=0b11000011;              //   (   )
        while (ADCSRA&0b01000000){}     //     
        DDRA.7=1;                       //  .7   
        }
        //***********************************************************    
       
        
        # if  OK
        PORTC.3 = (ekran [0] & stroka);
        PORTC.0 = (ekran [1] & stroka);
        PORTD.7 = (ekran [2] & stroka);
        PORTC.5 = (ekran [3] & stroka);
        PORTD.6 = (ekran [4] & stroka);        
        PORTC.4 = (ekran [5] & stroka);   
        PORTC.2 = (ekran [6] & stroka);
        PORTC.1 = (ekran [7] & stroka);    
        PORTA.5 = (ekran [8] & stroka);
        PORTD.5 = (ekran [9] & stroka);
        PORTD.4 = (ekran [10] & stroka);
        PORTA.3 = (ekran [11] & stroka);
        PORTD.3 = (ekran [12] & stroka);
        PORTA.4 = (ekran [13] & stroka);
        PORTA.6 = (ekran [14] & stroka);
        PORTA.7 = (ekran [15] & stroka);   
        PORTA.0 = (ekran [16] & stroka);
        PORTD.2 = (ekran [17] & stroka);
        PORTD.1 = (ekran [18] & stroka);
        PORTB.1 = (ekran [19] & stroka);
        PORTD.0 = (ekran [20] & stroka);
        PORTB.0 = (ekran [21] & stroka);
        PORTA.1 = (ekran [22] & stroka);
        PORTA.2 = (ekran [23] & stroka);  
        # endif 
        # if OA
        PORTC.1 = (ekran [0] & stroka);   //0  
        PORTC.3 = (ekran [1] & stroka);   //1
        PORTD.5 = (ekran [2] & stroka);   //2
        PORTC.2 = (ekran [3] & stroka);   //3
        PORTD.3 = (ekran [4] & stroka);   //4
        PORTD.6 = (ekran [5] & stroka);   //5      
        PORTD.4 = (ekran [6] & stroka);   //6
        PORTD.7 = (ekran [7] & stroka);   //7
        PORTD.1 = (ekran [8] & stroka);   //8
        PORTD.2 = (ekran [9] & stroka);   //9
        PORTA.3 = (ekran [10] & stroka);  //10
        PORTD.0 = (ekran [11] & stroka);  //11
        PORTB.1 = (ekran [12] & stroka);  //12
        PORTA.2 = (ekran [13] & stroka);  //13
        PORTB.0 = (ekran [14] & stroka);  //14
        PORTA.0 = (ekran [15] & stroka);  //15
        PORTA.1 = (ekran [16] & stroka);  //16
        PORTA.4 = (ekran [17] & stroka);  //17
        PORTC.0 = (ekran [18] & stroka);  //18
        PORTA.7 = (ekran [19] & stroka);  //19
        PORTA.5 = (ekran [20] & stroka);  //20
        PORTC.4 = (ekran [21] & stroka);  //21
        PORTA.6 = (ekran [22] & stroka);  //22
        PORTC.5 = (ekran [23] & stroka);  //23
        # endif

        
      
        PORTB.6=0;   

        
        but_pause++;  if (but_pause==100)      { but_pause=0; but_on=1; }                 //         0,3  -    
        if ((but_pause==30)&&(but_flg))        { but_flg=0; PORTB.5=0; TIMSK&=0xEF;}       //  ""         
        
        Interval++;   Interval_2++;                                                       //         

}

//___________________________________  _______________________________________________
unsigned char  button_read (void)
{
button=0;

if ( (PINB.2==0) && (but_on))  
{
but_on=0;  but_pause=0;
          
    switch (stroka)
        {
        case 0b10000000: button=2;                             //  
        break;
        case 0b00000001: button=1;
        break;
        }
time_meny=0;
if (zv_kn) {but_flg=1; TIMSK|=0x10;}//    -       .
if (bud_flg) {bud_flg=0; button=0;} //  (  )  .             .
bud_flg=0;
}
return  button;
}

//______  (        )______
interrupt [ANA_COMP] void ana_comp_isr(void)               
{
        if(ACSR&0x20)                //    
        {
        POWER = OFF;                 //      
        # if  ATMEGA16   
        MCUCR=0b01110000;            //      SLEEP ( 16)
        # endif
        # if  (ATMEGA32)  
        MCUCR=0b10110000;            //      SLEEP ( 32)
        # endif 
        TCCR0=0x00;                  //  /0
        ADCSRA=0x00;                 //   
        TIMSK&=0x7f;                 //     2
        ADMUX= 0b00100111;           //    
        PORTA=0;  DDRB=0b11110111;   //        
        PORTB=0; PORTC=0; PORTD=0;   
        }
        else                         //      
        {
        devices=w1_search(0xf0,rom_code);//    "" /  DS18B20,      ""
        POWER = ON;                  //    
        MCUCR=0b00110000;            //       SLEEP
        DDRB=0xE3;                   //                 
        TCCR0=0x03;                  //  /0
        ADCSRA=0b10000011;           //   
        TIMSK|=0x80;                 //     2
        ADMUX= 0b01100111;           //     
       if (devices==1){if (ds1820_d!=0)ds1820_d=0; if(ds1820_y!=1)ds1820_y=1;}

        }
}

//__________________________________________ __________________________________________________
interrupt [TIM1_COMPA] void timer1_compa_isr(void)
{
static char dl_1=0,dl_2=0;
dl_2++; if (dl_2>=150) {dl_2=0; dl_1++;  if (dl_1>=5) dl_1=0; }
if (but_flg) OCR1A=20;      //   ""   ,  ""    
else  OCR1A = dl_1+3;      //   "" ,   ""
PORTB ^= (1 << 5);
}

//____________________________  ________________________________
interrupt [TIM2_COMP] void timer2_comp_isr(void)
{

if (foto_r)                           //   
    {
    flg_adch=1;                       //   
    if (ADCH > brigh_up*70/100)       //  ""  70% 
        {
        TIMSK&=0xFD;                  //      (     ) 
        }
    else                              //  ""  70%  
        {
        OCR0=ADCH;                    //    .
        if (OCR0<20) OCR0=10;         //   ,         0
        TIMSK|=0x02;                  //     0 
        }
    }
else                                  //    
    {
    if (brigh_down_time<brigh_up_time)//     ""    ( )
        {
        if ( (time>=brigh_down_time)&&(time<brigh_up_time) )//
            {
            OCR0=(brigh_up*23)+1;     //    .
            TIMSK|=0x02;              //     0
            }
        else                          //
            {
            TIMSK&=0xFD;              //      (     )   
            }
        }
    else                              //     ""    ( )
        {
        if ( (time<brigh_down_time)&&(time>=brigh_up_time) )//
            {
            TIMSK&=0xFD;              //      (     )  
            }
        else                          //
            {
            OCR0=(brigh_up*23)+1;     //    .
            TIMSK|=0x02;              //     0 
            }
        }
    }
//_______________________________________________________________________________
flg_ds18b20=1; //                  
}

//____________________________________________ ________________________________________________
interrupt [TIM2_OVF] void timer2_ovf_isr(void)

{ 
mig++; 
sek++;     //   
if(!mig_vrem) time_meny++;  else  time_meny=0;
if (sek==60) 
        {sek=0; time++; flg_min=1; 
         if (time==1440)
                { 
                if(flg_korr)  {correkt(); flg_korr=0;  if(korr_den<0) goto m2;}  //   00-00,       -  .    
                time=0;  chislo++; if (chislo > dnei_v_mesc[mesec-1])
                        {chislo=1; mesec++; if (mesec==13)
                                {mesec=1; god++;
                                }
                        }
                if ( (god%4) && (mesec==2) && (chislo==29) )  {mesec=3; chislo=1;}      //   ,  29.02>>>>>01.03
                flg_korr=1;
                m2:                                           
                }
        }
          
      
                                                   
}




//______________________     +    _________________________
 void ekran_cifri (unsigned  int data)
{  
    unsigned char           x,x1,x2,x3,y,y1,y2,y3,temp; 
    static unsigned char    Shift_zn;  

    
x  =  data/600;              // 
x1 =  (data%600)/60;
x2 =  (data%60)/10;  
x3 =  data%10;

y  =  data1/600;
y1 =  (data1%600)/60;
y2 =  (data1%60)/10;
y3 =  data1%10;
                                                                                
if ((budilnik_Install[0] & 0x80) | (budilnik_Install[1] & 0x80)                                                    //    
                 | (budilnik_Install[2] & 0x80) | (budilnik_Install[3] & 0x80) | (budilnik_Install[4] & 0x80)
                 | (budilnik_Install[5] & 0x80) | (budilnik_Install[6] & 0x80)| (budilnik_Install[7] & 0x80)
                 | (budilnik_Install[8] & 0x80) ) {  budilnik=1;   } 
                      else  {  budilnik=0;  }   
                      
  if(mig_vrem) {      if (mig)  {ekran [12]=128;  ekran [11]=0;}
                                        else  {ekran [12]=0;  ekran [11]=128;}                                 //     
                       
                }         

  
if (data != data1)                                                                                             //     -  
{    
    if (Interval_2>40){Interval_2=0; Shift_zn++;  if(Shift_zn==8) {Shift_zn=0;data1=data;}   }
    {    mig_vrem=0; 

    for (temp=0; temp<5; temp++)
    { 
     if(sek0 || time>=600){if(x !=y ) {ekran [temp   ] =  (   (simvol [y ][temp]<<Shift_zn)  +   (simvol [x ][temp]>>(8-Shift_zn))   );}   else  {  if(sek0 || time>=600) {ekran [temp   ]=(simvol [x ][temp]);} else  {ekran [temp   ]=(simvol [55 ][temp]);} }     
                          }
    if(x1!=y1) {ekran [temp+ 6] =  (   (simvol [y1][temp]<<Shift_zn)  +   (simvol [x1][temp]>>(8-Shift_zn))   );}   else  { if(temp==4 & mig_vrem & budilnik & !mig) {ekran [temp+ 6]=(simvol [x1][temp])+128;}
                                                                                                                             else  {ekran [temp+ 6]=(simvol [x1][temp]); } }
    if(x2!=y2) {ekran [temp+13] =  (   (simvol [y2][temp]<<Shift_zn)  +   (simvol [x2][temp]>>(8-Shift_zn))   );}   else  { if(temp==0 & mig_vrem & budilnik & mig) {ekran [temp+13]=(simvol [x2][temp])+128;} 
                                                                                                                             else  {ekran [temp+13]=(simvol [x2][temp]);} }
                ekran [temp+19] =  (   (simvol [y3][temp]<<Shift_zn)  +   (simvol [x3][temp]>>(8-Shift_zn))   );  
                    
    }
    }
     
}
else
{
   for (temp=0; temp<5; temp++)
    {                                                                                                    
    if(sek0 || time>=600) {ekran [temp   ]=(simvol [x ][temp]);} else  {ekran [temp   ]=(simvol [55 ][temp]);}                 // 0    . 
          

   if(temp==4 & mig_vrem & budilnik & !mig) {ekran [temp+ 6]=(simvol [x1][temp])+128;}
                                 else  {ekran [temp+ 6]=(simvol [x1][temp]); }
   if(temp==0 & mig_vrem & budilnik & mig) {ekran [temp+13]=(simvol [x2][temp])+128;} 
                                else  {ekran [temp+13]=(simvol [x2][temp]);}
    ekran [temp+19]=(simvol [x3][temp]);
    }
    
                   
    Interval_2=0;
}

}

//___________________________     1 _________________________________
 void ekran_1_figure (unsigned char x,unsigned char x1,unsigned char x2,)          
{                                                                                                                         
   unsigned char temp;                                                          
   for (temp=0; temp<5; temp++)
   {
   if (simvol [x][temp]==0xAA) return;                                                                                                            
   if(x2!=0) {ekran [temp+x1]=(simvol [x][temp])  +(128*mig*line);}
      else   {ekran [temp+x1]=(simvol [x][temp]) ;}
   }
}

//_______________________________________  __________________________________________________
void ochistka (void)
{
unsigned char temp;
for (temp=0;  temp<24; temp++) {ekran[temp]=0  ;}
}

//_________________________________________!__2_____________________________________________  
  unsigned  char ystanovki_2 (unsigned  char x,unsigned  char x1,unsigned  char x2)
  {  
   
  unsigned  char temp; 
     
           if ((x==0) && (x1==15))x=1;
        while ( (button_read() != 2)  &&  POWER )  // POWER
        {        if(time_meny== RET_CLOCK) { ochistka();meny=10;return x;} ; 
        if (BUT_OK ) {x++;   if (x>x1) { if ( ( x1==12 )|| (x1==31)|| (x1==15)){x=1;}                   //       snm 
                                              else { x=0;};
                                       }       
                     }                     
                                                                                                                                   
                for (temp=0; temp<5; temp++)
                {                                                                                                           
                
                 
                     ekran [temp+x2]  =(simvol [x/10][temp])   +(128*mig);
                
                     ekran [temp+x2+6]=(simvol [x%10][temp])   +(128*mig); 
                }
        }
  ochistka();  
          
                             
                                  return x;              
  }
  
//_________________________________________________________________________________________________
  unsigned  int ystanovki_23_59 (unsigned  int x)
  {
  ochistka();
  
  ekran_1_figure((x%60)/10,13,1);  ekran_1_figure(x%10,19,1);
  x = (x%60)+   (ystanovki_2 ((x/60),23, 0))*60;
  ekran_1_figure(x/600,0,1);  ekran_1_figure((x/60)%10,6,1);
  x = (x/60*60)+(ystanovki_2 ((x%60),59,13)); 
   
  return x;
  }

//_________________________________________ ___________________________________________________
unsigned char beg_stroka (unsigned char x[],)
{  
  unsigned char temp;
                    for (temp=0; temp<23; temp++)  {ekran[temp]=ekran[temp+1];}
  if ((z==5)||(simvol[x[z1]][z]==0xAA)) {ekran[23]=0;z=0; z1++; if (x[z1]==255) {z1=0; for (temp=23; temp>0; temp--)  { ekran[temp] = ekran[temp-1]; } ;ekran[0]=0; return 255;} }
                  else  {ekran[23]=simvol[x[z1]][z]; z++;} 
                    
}  
 //_________________________________________       ___________________________________________________
unsigned char beg_stroka_revers (unsigned char x[],)
{    
unsigned char temp,;
           
                if  (simvol[x[z1]][4-z]==0xAA)  {z=4;};
                 if ((z==4) && (x[z1+1]==255)) { ekran[0]=0;z1=0; return 255;};
                                                                                                                                 
                if (z==5) {ekran[0]=0;z=0; z1++; }                         
                    else  {ekran[0]=simvol[x[z1]][4-z]; z++;} 
          for (temp=23; temp>0; temp--)  { ekran[temp] = ekran[temp-1]; }        
                 
 
} 
//__________________________________  _______________________________________________
void txt_ekran (unsigned char x[],)
{
unsigned char temp =0,  temp1=0, temp2=0;

    for(temp=0;temp<24;temp++)
    {
    if ((temp2==5) || (simvol[x[temp1]][temp2] == 0xAA)) {ekran[temp]=0;   temp2=0; temp1++;} 
        else {ekran[temp]=simvol[x[temp1]][temp2]; temp2++;}
    if (x[temp1]==255) return ; //{temp=24;}
    }
}

//*****************************************************************************************************************//
//*****************************************************************************************************************//
//*****************************************************************************************************************//
//*****************************************************************************************************************//
void main(void)
{
PORTA=0x00; DDRA=0xFF;
PORTB=0x00; DDRB=0xE3; 
PORTC=0x00; DDRC=0x3F;
PORTD=0x00; DDRD=0xFF;                                                   

TCCR0=0x03;           //  0 125,000 kHz   (8000000/64)
OCR0=254;             //

TCCR1B=0x0C;          //  1 125,000 kHz   (8000000/64)
OCR1A=20;

ASSR=0x08;            //    TOSC1,2    32768
TCCR2=0x05;           // 32768/128=256 
OCR1A=127;            //

TIMSK=0xC3;           //     

ACSR= 0x48;           // .  
SFIOR=0x00;

MCUCR|=0b00110000;    //     - Power Sawe

ADCSRA=0b10000011;    //  .    - 1.
ADMUX= 0b01100111;    // -AVcc.     7,                

#asm                                //     1 Wire
   .equ __w1_port=0x18 ;PORTB       //     
   .equ __w1_bit=4                  //  4
#endasm

for (temp=0;temp<9;temp++){budilnik_time [temp] = budilnik_Install [temp] = budilnik_Interval[temp]= 0;}  bud_flg=0; budilnik=0 ; // ""  
den_nedeli=Day_week ();             //   
devices=w1_search(0xf0,rom_code);   //   DS18B20,      
if (devices==1){
if (ds1820_d!=0)ds1820_d=0; if(ds1820_y!=1)ds1820_y=1;
               }

//**********     .
PORTB.6=1;                      //      Z  (     )
PORTA.7=0; DDRA.7=0;            //  .7   ,         , 
ADCSRA=0b11000011;              //   (   )
while (ADCSRA&0b01000000){}     //     
DDRA.7=1;                       //  .7   
if (ADCH>5) {foto_r=1; brigh_up=254;} //else brigh_up=9;   // 
ochistka();  //   
//#asm("cli")    
#asm("sei")
//_______________________________________   ___________________________________________
ochistka(); 
     
 //   ekran [10]=ekran [11]=ekran [12]=128;
  //  ekran_1_figure(52,0,1); ekran_1_figure(VER/100,5,1);  ekran_1_figure(VER%100/10,13,1); ekran_1_figure(VER%10,19,1);
   // delay_ms(1000);
  
  

 ochistka();    //   

//*****************************************************************************************************************//
//*****************************************************************************************************************//
while (1)
{
button_read();   //  
if( time_meny== RET_CLOCK) { time_meny=0; ochistka(); meny=10;}            //     RET_CLOCK  .  
                                               
                             
switch (meny)
        {
        case 10: //______  
               
         mig_vrem=1; 
                 ekran_cifri(time);  //     
              
                      
                //______ 
                 if ( ( flg_ds18b20 ) && ( bud_flg == 0 ) )                                                      //               if ( flg_ds18b20 )
                        {
                        flg_ds18b20=0;  
                        for (i=0;i<devices;i++)
                                {    
                                error_ds18b20[i]++;                                                               //      DS18B20 
                                temperature_temp=ds18b20_read_temp (&rom_code[i][0]);                             //    DS18B20                    
                                if (temperature_temp!=(-9999))                                                    //    ,    "temperature"
                                                            {                                              
                                                            temperature[i]=temperature_temp*10;
                                                            // temperature[i]+=5;                                 //      "temperature" + 0,5 C                 
                                                            error_ds18b20[i]=0;                                   //      DS18B20 
                                                            }
                                if(error_ds18b20[i]==255)  temperature[i]=-999;                                   //   DS18B20  5     ,    (  -99,9 )
                                ds18b20_convert_temp(&rom_code[i][0]);                                            //       
                                }
                        }  
                        
                if ((sek==9)  && (str != 0) &&  (mig_vrem))  {  temp2=str;                                                      //     10    
                                                   if (( (temp2 & 0x01) || (temp2 & 0x02) || (temp2 & 0x04) ||
                                                        ((temp2 & 0x08) && (devices>0)) || ((temp2 & 0x10) && (devices>0))      //          
                                                      ) )   
                                                         {  z=0; z1=0;temp=0; meny=11 ; temp2=str;  mig_vrem=1;}
                                                                                                                         
                                                   
                                                }  
             if (sek_ind) { if ((sek!=0)&& (sek%10==0) && (str != 0) && (mig_vrem) )  { z=0; z1=0;temp=0; meny=12 ; temp2=str;}};                   //                      
               mig_vrem=0; 

                if (BUT_STEP) {ochistka(); z=0; z1=0;  t=0; temp1=0;   meny=30;  bud_flg=0;data1=(((time-(time/60*60))*60)+sek);}
                if (BUT_OK)   {  meny=20 ;z=0; z1=0; temp2=0xFF;}                //   0x18;
        break;
        case 12:  //_________//______          
                 mig_vrem=0;   
                t=0; temp1=0; 
                beg_info[t++]=44;
                beg_info[t++]= (sek%60)/10;          //       
                beg_info[t++]= sek%10;                //       
                beg_info[t]=255;                     //      " "
                if (Interval >= speed)  {Interval=0; if (beg_stroka (beg_info)==255) {delay_ms(1000); t=0; temp1=0; meny=13; data1=time;}}   //   
                if (BUT_STEP) {ochistka();  z=0; z1=0; t=0; temp1=0; meny=30; } 
                if (BUT_OK)   { ochistka();meny=20;}                                                                     
                  
         break;
        case 13:   //______           
                mig_vrem=0; 
                    t=0; temp1=0; 
                    beg_info[t++]=54;
                    beg_info[t++]=(time%600)/60;                            //     
                    if (time/600!=0) { beg_info[t++]=time/600;}              //      
                              else   {beg_info[t++]=55;}
                    beg_info[t]=255;                                        //      " " 
                    if (Interval >= speed)  {Interval=0; if (beg_stroka_revers(beg_info)==255) { meny=10; ochistka(); data1=time;}}        //    
                    if (BUT_STEP) {ochistka(); z=0; z1=0;  t=0; temp1=0;   meny=30; } 
                    if (BUT_OK)   {ochistka();meny=20;}
        break;
                 
        //*******  .        . **********     
        case 11: //______    . 
            
                 mig_vrem=0;   
                t=0; temp1=0; 
                 den_nedeli=Day_week ();
               
                beg_info[t++] = beg_info[t++] = beg_info[t++] = 42;            // 3       
                
                if (temp2 & 0x01)                                              //  " "  
                        {
                        while (den_nedeli_txt[den_nedeli][t-3] != 255)         // 
                                {                                              //
                                beg_info[t]=den_nedeli_txt[den_nedeli][t++-3]; //
                                } beg_info[t++] = 42;                          //  
                        }                             
                if (temp2 & 0x02)                                              //   ""  
                        {                                                      //
                        if (chislo>9) {beg_info[t++]=chislo/10;}               //     9,  "" 
                        beg_info[t++]=chislo%10;                               //   "" 
                        beg_info[t++]=42;                                      //                        
                        temp1=t;
                        while (name_mesec_txt[mesec-1][(t-temp1)] != 255)      //   
                                {     
                                beg_info[t]=name_mesec_txt[mesec-1][t++-temp1];
                                } beg_info[t++] = 42;                          // 
                        } 
                if (temp2 & 0x04)                                              //   ""  
                        {
                        beg_info[t++]=2;                                       // ""  (2)
                        beg_info[t++]=0;                                       // ""   (0)
                        beg_info[t++]=(god%100)/10;                            // "" 
                        beg_info[t++]=god%10;                                  // "" 
                        beg_info[t++]=13;                                      // ""
                        beg_info[t++]=42; beg_info[t++]=42;                    // 2 
                        }
                if (  (temp2 & 0x08) && (devices>0) )                                       //   "  "  
                        {
                        beg_info[t++]=42;                                                    //  
                        if ((temp2 & 0x10) && (devices>1)) {
                                                            beg_info[t++]=14;  beg_info[t++]=24;   //  "" 
                                                            beg_info[t++]=22;  beg_info[t++]=10;   //  "" 
                                                            beg_info[t++]=42;                      // 
                                                            }   
                        beg_info[t++]=44;                                                    //   
                         if (temperature[ds1820_d]!=0){
                         if (temperature[ds1820_d]<0) beg_info[t++]=51;  else beg_info[t++]=47;              //     -   ,    -  
                                                      };
                        if (abs(temperature[ds1820_d])>99) {beg_info[t++]=(abs(temperature[ds1820_d])/100);}//   >10,   ""  
                        if (td10==0){if (abs(temperature[ds1820_d]%10)>=5) {if (temperature[ds1820_d]<0){temperature[ds1820_d]-=1;}else{temperature[ds1820_d]+=1;}}}  //  1          0.5 C
                        beg_info[t++]=(abs(temperature[ds1820_d])%100)/10;                   //  " "
                        //______________________________________________________     ____________________________________
                        if (td10==1){beg_info[t++]=43;                                                 //  
                                   beg_info[t++]=abs(temperature[ds1820_d])%10;                      //   .
                                  }
                        //____________________________________________________________________________________________________________________________          
                        beg_info[t++]=48;                                                    //       
                        beg_info[t++]=42;                                                    // 
                        }             
                if ( (temp2 & 0x10) && (devices>1) )                                        //   "  "  
                        {
                         beg_info[t++]=23;  beg_info[t++]=10;                                 //   ""
                         beg_info[t++]=42;                                                    // 
                        beg_info[t++]=29;  beg_info[t++]=21;                                 //   ""
                        beg_info[t++]=18;  beg_info[t++]=32;  beg_info[t++]=15;              //   "" 
                         beg_info[t++]=42;                                                    //  
                        if (temperature[ds1820_y]!=0){
                        if (temperature[ds1820_y]<0) beg_info[t++]=51;     else beg_info[t++]=47;          //     -      
                                                      };
                        if (abs(temperature[ds1820_y])>99){beg_info[t++]=(abs(temperature[ds1820_y])/100);}//    >10,   ""  
                        if (tu10==0){if (abs(temperature[ds1820_y]%10)>=5) { if (temperature[ds1820_y]<0){temperature[ds1820_y]-=1;}else{temperature[ds1820_y]+=1;}}}  //  1          0.5 C
                        beg_info[t++]=(abs(temperature[ds1820_y])%100)/10;                                 //  " "
                        //         -    
                        if (tu10==1){ beg_info[t++]=43;                                                 //  
                                   beg_info[t++]=abs(temperature[ds1820_y])%10;                      //   .
                                  }
                        beg_info[t++]=48;                                                    //    
                        beg_info[t++]=42;  beg_info[t++]=42;                                 //  
                        }

                                         
                if (time/600!=0) { beg_info[t++]=time/600;} else beg_info[t++]=42;        //     
                beg_info[t++]=(time%600)/60;         //     
                beg_info[t++]=44;                    //     
                beg_info[t++]=(time%60)/10;          //     
                beg_info[t++]=time%10;               //       
           
                beg_info[t]=255;                     //      " "
         
                if (Interval >= speed)  {Interval=0; if (beg_stroka(beg_info)==255) {if (temp==255)  ochistka(); meny=10; data1=time;}}   
               if (BUT_STEP) { ochistka();  z=0; z1=0;  t=0; temp1=0;   meny=30;} 
               if (BUT_OK)   { ochistka();  z=0; z1=0;  t=0; temp1=0;   meny=10;}
        break;
        case 20: //********************************************************************* 
        sek0=1;
        ekran [12]=0;  ekran [11]=128; 
        ekran_cifri(((time-(time/60*60))*60)+sek);
        sek0=0;
        if (BUT_STEP)  {if (sek>40) {time++; if (time==1440) time=0;}  sek=0; TCNT2=0;  temp=10;}
        if (BUT_OK)    {  z=0; z1=0;  t=0; temp1=0;   ochistka(); meny=11;}
        break;
        
        //**************************** *********************************** 
        case 30: //     - ""  
            if (Interval>=speed)  {Interval=0;  beg_stroka(budilnik_txt);}
            if (BUT_STEP)         {  t=0; temp1=0; meny=40;z=0; z1=0;ochistka();}
            if (BUT_OK)           {ochistka(); bud=0; temp=0; meny=32;}
        break;
        case 32: //    
            if (BUT_STEP) {meny=34;}
            if (BUT_OK  ) {bud++; if (bud==9) bud=0;  }
            ekran_1_figure(11,1,1); line=1; ekran_1_figure(bud+1,7,1); line=0; ekran_1_figure(((budilnik_Install[bud] & 0x80) ? (47):(46)),17,1);
        break;
        case 34: //     .    -    ""
            if (BUT_STEP)                       
                    {
                    if (budilnik_Install[bud] & 0x80)    //    
                        { 
                        budilnik_time[bud]= ystanovki_23_59 (budilnik_time[bud]);     //    
                            if (bud<3){budilnik_Install[bud] = 0xFF; goto m1;}        //   1-3   "  "  ,         
                            else {temp=0;  meny=36;}                                  //   4-9                                                   
                        }
                    else { ochistka(); z=0; z1=0;  t=0; temp1=0; meny=10;}   ochistka();  break;                      //     -    ""
                    }
            if (BUT_OK )  {budilnik_Install[bud] ^= 0x80;}                     //    /   (/  1 7)
            ekran_1_figure(11,1,1); ekran_1_figure(bud+1,7,1); line=1; ekran_1_figure(((budilnik_Install[bud] & 0x80) ? (47):(46)),17,1); line=0;
        break;
        case 36:  //        ,    .
            ekran_1_figure (den_nedeli_letter[temp][0],0,1);  ekran_1_figure (den_nedeli_letter[temp][1],6,1);                 //    . ( "beg_info"    )   
            ekran_1_figure (((budilnik_Install[bud] & (1 << temp)) ? 47:46),17,1);                                             //   "+"  "-"    ./. .
            
            if (BUT_STEP) {temp++;  ochistka(); z=0; z1=0;  t=0; temp1=0;                                                      // ""     
                          if (temp==7){m1:  ochistka(); z=0; z1=0;  t=0; temp1=0;meny=38;  }           //      ,     .
                          }
            if (BUT_OK){(budilnik_Install[bud]) ^= (1 << temp);}                                                               // /     .
        break;             
         case 38: //*********************    *********************************//
               if (Interval>=speed)  {Interval=0;  if ( beg_stroka(budilnik_Interval_txt)==255) {delay_ms(500);ochistka(); z=0; z1=0;  t=0; temp1=0;meny=39;}} ;
               if (BUT_OK) { ochistka(); z=0; z1=0;  t=0; temp1=0;meny=39; }
        break;
        case 39:
          if( budilnik_Interval[bud]==0)budilnik_Interval[bud]=1;
               if( budilnik_Interval[bud]<10){ ekran_1_figure(((budilnik_Interval[bud])%10),2,1);
                ekran_1_figure(22,9,0); ekran_1_figure(18,15,0); ekran_1_figure(23,20,0);}
                else {          
                       ekran_1_figure(((budilnik_Interval[bud])/10),0,1); ekran_1_figure(((budilnik_Interval[bud])%10),5,1);
                        ekran_1_figure(22,11,0); ekran_1_figure(18,16,0); ekran_1_figure(23,20,0);  
                     }         
                 if (BUT_STEP) { ochistka(); z=0; z1=0;  t=0; temp1=0;meny=10; } 
                 if (BUT_OK)   { budilnik_Interval[bud]+=1; ochistka();  if( budilnik_Interval[bud]>15)budilnik_Interval[bud]=1;};
        break;
                                                                                        
         case 40: //*********************   **************************** 
               
                if (Interval>=speed)  {Interval=0; beg_stroka(nastroiki_txt);}
                if (BUT_STEP) {meny=50; z=0; z1=0; ochistka();}
                if (BUT_OK)
                        {
                        time   =ystanovki_23_59(time);
                        ochistka();
                        ekran_1_figure(33,1,1);          ekran_1_figure(43,6,1);
                        chislo =ystanovki_2 (chislo,31, 13);
                        ekran_1_figure(22,1,1);          ekran_1_figure(43,7,1);
                        mesec  =ystanovki_2 (mesec, 12, 13);
                        ekran_1_figure(13,1,1);          ekran_1_figure(43,5,1);
                        god    =ystanovki_2 (god,   99, 13);
                        button=0;ochistka(); temp=0 ;meny=10;
                        }
        break;
        
        case 50: //    - ""
               if (Interval>=speed)  {Interval=0;   beg_stroka(nastr_stroki_txt);} 
               if (BUT_STEP) { z=0; z1=0; ochistka();meny=60;}
               if (BUT_OK)   {z=0; z1=0;temp=0;meny=51; ochistka(); }
        break;
        case 51:
                if (BUT_STEP) {temp++; ochistka();}
                switch (temp)
                        {
                        case 0:  if (BUT_OK){str ^= (1 << 0);}      txt_ekran(den_txt);  ekran_1_figure (((str & 0x01) ? 47:46),19,1);            break;                                            
                        case 1:  if (BUT_OK){str ^= (1 << 1);}      txt_ekran(data_txt); ekran_1_figure (((str & 0x02) ? 47:46),19,1);            break;    
                        case 2:  if (BUT_OK){str ^= (1 << 2);}      txt_ekran(god_txt);  ekran_1_figure (((str & 0x04) ? 47:46),19,1);            break; 
                        case 3:  if (BUT_OK){sek_ind++;      }      ekran_1_figure (((sek_ind) ? 47:46),19,1);      ekran_1_figure(27,0,1); ekran_1_figure(15,5,1); ekran_1_figure(20,9,1); ekran_1_figure(43,15,1); break;
                        case 4:  if (BUT_OK){zv_chs++;       }      ekran_1_figure (((zv_chs) ? 47:46),19,1);       ekran_1_figure(16,0,1); ekran_1_figure(12,5,1); ekran_1_figure(43,9,1); ekran_1_figure(33,10,1); ekran_1_figure(27,14,1); break;
                        case 5:  if (BUT_OK){zv_kn++;        }      ekran_1_figure (((zv_kn)  ? 47:46),19,1);       ekran_1_figure(16,0,1); ekran_1_figure(12,5,1); ekran_1_figure(43,9,1); ekran_1_figure(20,10,1); ekran_1_figure(23,14,1); break;
                        case 6:  if (devices==2){if (Interval>=speed)  {Interval=0;   beg_stroka(perenazna_datchik);};if (BUT_OK){ochistka();meny=53;};} else {temp++;} break;
                        case 7:  if (devices==1){ if (BUT_OK){str ^= (1 << 3); }     ekran_1_figure (((str & 0x08) ? 47:46),19,1);   ekran_1_figure(50,0,1); ekran_1_figure(48,4,1);break;}  
                        else    {if (devices>1){  if (BUT_OK){str ^= (1 << 3); }     ekran_1_figure (((str & 0x08) ? 47:46),19,1);   ekran_1_figure(50,0,1); ekran_1_figure(48,4,1); ekran_1_figure(14,10,1);} else {temp++;} break;}        //   
                        case 8:  if ((str & 0x08) && (devices>0))  { z=0; z1=0;meny=57;} else {temp++;}  break;
                        case 9:  if (devices>1){if (BUT_OK){str ^= (1 << 4);}      ekran_1_figure (((str & 0x10) ? 47:46),19,1);   ekran_1_figure(50,0,1); ekran_1_figure(48,4,1); ekran_1_figure(29,10,1);} else {temp++;}  break;       //    
                        case 10: if ((str & 0x10) && (devices>1))  {z=0; z1=0; meny=58;} else {temp++;}  break;
                        case 11: z=0; z1=0; meny=52; temp=speed; break;
                        }
        break;
        case 52: //    
            if (Interval>=temp)  {Interval=0; beg_stroka(speed_txt);} 
            if (BUT_OK)  {temp+=3;  if (temp>=60) {temp=9;} ochistka();ekran_1_figure((((60-temp)/3)/10),8,1); ekran_1_figure((((60-temp)/3)%10),14,1);delay_ms(1000);z=0; z1=0;  t=0; temp1=0; ochistka(); }
            if (BUT_STEP)   {speed=temp;ochistka(); if(foto_r)meny=56; else meny=54;} //    ,     . temp5=0
                                                                                                                        //   ,            .
        break;                                                                                                          
        case 53: //    ds18m20 (  2 )
            
            ekran_1_figure (14,0,1); 
            ekran_1_figure (((temperature[temp5]<0) ? 51:47),8,1);
            ekran_1_figure ((abs(temperature[temp5])/100),13,1);
            ekran_1_figure (((abs(temperature[temp5])%100)/10),19,1);
            if (BUT_OK)  {temp5++;}
            if (BUT_STEP)   { ochistka();z=0; z1=0;  t=0; temp1=0;   if (temp5)  {ds1820_d=1; ds1820_y=0;}  else {ds1820_d=0; ds1820_y=1;} ;{ochistka(); temp=7; meny=51;}} ;  
        break; 
       
         
        case 57:  // __________________________    ________________________________________________________
           t=0; temp1=0;
                 beg_info[t++] = beg_info[t++] = beg_info[t++] = 42;   beg_info[t++]=44; 
                 if (td10==0){ 
                                beg_info[t++]=11; beg_info[t++]=15;
                                beg_info[t++]=16; beg_info[t++]=42;
                                beg_info[t++]=28; beg_info[t++]=24;   //  "T" 
                                beg_info[t++]=33;  beg_info[t++]=20;   //  "" 
                                beg_info[t++]=18;                     //  ""  
                             } 
                
            else {
                      beg_info[t++]=27;                     //       ""
                      beg_info[t++]=42;
                      beg_info[t++]=28; beg_info[t++]=24;   //  "T" 
                      beg_info[t++]=33;  beg_info[t++]=20;   //  "" 
                      beg_info[t++]=24;  beg_info[t++]=19;   //  ""
                  }     
                 beg_info[t++]=42;  beg_info[t++]=50;   //  " t" 
                 beg_info[t++]=42;          
                if (devices>1) {   beg_info[t++]=14;  beg_info[t++]=24;   //  "" 
                                    beg_info[t++]=22;  beg_info[t++]=10;   //  "" 
                                    beg_info[t++]=42;
                                 }             
         if (td10==0){
                        if (temperature[ds1820_d]!=0){
                         if (temperature[ds1820_d]<0) beg_info[t++]=51;  else beg_info[t++]=47;             //     -   ,    -  
                              }; 
                        if (abs(temperature[ds1820_d])>99) {beg_info[t++]=(abs(temperature[ds1820_d])/100);}//   >10,   ""  
                        if (abs(temperature[ds1820_d]%10)>=5) {if (temperature[ds1820_d]<0){temperature[ds1820_d]-=1;}else{temperature[ds1820_d]+=1;}}  //  1          0.5 C
                        beg_info[t++]=(abs(temperature[ds1820_d])%100)/10;                   //  " "
                        beg_info[t++]=48;                                                    //     
                        beg_info[t]=255;  
                     }
          else {       
                        if (temperature[ds1820_d]!=0){
                        if (temperature[ds1820_d]<0) beg_info[t++]=51;  else beg_info[t++]=47;             //     -   ,    -  
                                                     }; 
                        if (abs(temperature[ds1820_d])>99) {beg_info[t++]=(abs(temperature[ds1820_d])/100);}//   >10,   ""  
                        beg_info[t++]=(abs(temperature[ds1820_d])%100)/10;                                  //  " "
                        beg_info[t++]=43;                                                                   //  
                        beg_info[t++]=abs(temperature[ds1820_d])%10;                                        //   .
                        beg_info[t++]=48; 
                        beg_info[t]=255;                                                
               }   
           if (Interval >= speed)  {Interval=0; if (beg_stroka(beg_info)==255) ;}    
        
         if (BUT_OK) { ochistka(); z=0; z1=0;temp=0; if (td10==0){td10=1;}
                             else  td10=0;
                             meny=57;
                     }             
         if (BUT_STEP) {ochistka(); temp=9; meny=51;}                                     //         .
         
        break; 
         case 58:  // __________________________    ________________________________________________________
           t=0; temp1=0;
                
                
                 beg_info[t++] = beg_info[t++] = beg_info[t++] = 42;   beg_info[t++]=44; 
                 if (tu10==0){ 
                                beg_info[t++]=11; beg_info[t++]=15;
                                beg_info[t++]=16; beg_info[t++]=42;
                                beg_info[t++]=28; beg_info[t++]=24;    //  "T" 
                                beg_info[t++]=33;  beg_info[t++]=20;   //  "" 
                                beg_info[t++]=18;                      //  ""  
                             } 
                
            else {
                      beg_info[t++]=27;                     //       ""
                      beg_info[t++]=42;
                      beg_info[t++]=28; beg_info[t++]=24;   //  "T" 
                      beg_info[t++]=33;  beg_info[t++]=20;   //  "" 
                      beg_info[t++]=24;  beg_info[t++]=19;   //  ""
                  } 
                      
                 beg_info[t++] = 42; beg_info[t++]=50;   //  " t" 
                 beg_info[t++] = 42; 
                 beg_info[t++]=23;  beg_info[t++]=10;                                                        //   ""
                 beg_info[t++]=42;                                                                           // 
                 beg_info[t++]=29;  beg_info[t++]=21;                                                        //   ""
                 beg_info[t++]=18;  beg_info[t++]=32;  beg_info[t++]=15;                                     //   "" 
                 beg_info[t++]=42;           
         if (tu10==0){
                        if (temperature[ds1820_y]!=0){
                        if (temperature[ds1820_y]<0) beg_info[t++]=51;  else beg_info[t++]=47;               //     -   ,    -  
                                                       }; 
                        if (abs(temperature[ds1820_y])>99) {beg_info[t++]=(abs(temperature[ds1820_y])/100);} //   >10,   ""  
                        if (abs(temperature[ds1820_y]%10)>=5) {if (temperature[ds1820_y]<0){temperature[ds1820_y]-=1;}else{temperature[ds1820_y]+=1;}}                    //  1          0.5 C
                        beg_info[t++]=(abs(temperature[ds1820_y])%100)/10;                                   //  " "
                        beg_info[t++]=48;                                                                    //     
                        beg_info[t]=255;  
                     }
          else {       
                         if (temperature[ds1820_y]!=0){
                         if (temperature[ds1820_y]<0) beg_info[t++]=51;  else beg_info[t++]=47;             //     -   ,    -  
                                                       };  
                        if (abs(temperature[ds1820_y])>99) {beg_info[t++]=(abs(temperature[ds1820_y])/100);} //   >10,   ""  
                     
                        beg_info[t++]=(abs(temperature[ds1820_y])%100)/10;                                   //  " "
                        beg_info[t++]=43;                                                                    //  
                        beg_info[t++]=abs(temperature[ds1820_y])%10;                                         //   .
                        beg_info[t++]=48; 
                        beg_info[t]=255;                                                  
               }   
           if (Interval >= speed)  {Interval=0; if (beg_stroka(beg_info)==255) ;}    
        
         if (BUT_OK) { ochistka();z=0; z1=0;temp=0;if (tu10==0){tu10=1;}
                             else  tu10=0; 
                             meny=58;
                     }             
              if (BUT_STEP) {ochistka(); temp=11; meny=51;}  
              
        break;                                                     
        case 54: //        ()
            TIMSK&=0x7F;         //   ""  .  (  ,    ""   )
            brigh_down_time=ystanovki_23_59(brigh_down_time); //     
            ochistka();
            brigh_up_time=ystanovki_23_59(brigh_up_time);     //     
            ochistka();
            meny=55;
        break;    
        case 55: //                         
            ekran_1_figure(41,0,1);  
            ekran_1_figure(26,5,1);
            ekran_1_figure(20,10,1);
            ekran_1_figure(brigh_up,18,1);
            TIMSK|=0x02;                //    (    0)
            OCR0=(brigh_up)*23+5;       //         brigh_up
            if (BUT_OK)  {brigh_up++; if(brigh_up==10) brigh_up=0;} //
            if (BUT_STEP)   {  TIMSK|=0x80; ochistka();z=0; z1=0;  t=0; temp1=0;   data1=time; meny=10;}   //
        break;   
        case 56: //   
            ekran_1_figure(ADCH/100,3,1);  
            ekran_1_figure((ADCH/10)%10,9,1);
            ekran_1_figure(ADCH%10,15,1);
            if (BUT_OK)  {brigh_up=ADCH;}  //         brigh_up
            if (BUT_STEP)   {ochistka(); z=0; z1=0;  t=0; temp1=0;temp=0;data1=time;meny=10;} 
        break;
        //**************************  ******************************* 
        case 60: //    - ""
            if (Interval>=speed)  {Interval=0;   beg_stroka(korekt_txt);} 
            if (BUT_STEP) {ochistka(); z=0; z1=0;  t=0; temp1=0;temp=0;meny=10; }
            if (BUT_OK)   {ochistka();meny=61;}
        break;
        case 61: //  ""  
            if (BUT_STEP) {meny=62;}
            if (BUT_OK)   {korr_den = (korr_den * (-1));} 
              ekran [11]=192;line=1; ekran_1_figure(((korr_den<0)?46:47),0,1);  
            line=0;/* ekran_1_figure((abs((korr_den))/100),6);*/ ekran_1_figure(((abs(korr_den)%100)/10),6,1); ekran_1_figure((abs(korr_den)%10),12,1);ekran_1_figure(27,19,0);   //   
        break;
        case 62: //       
            if (BUT_STEP) {;meny=63;}
            if (BUT_OK)   {korr_den=((korr_den<0)?(korr_den-=10):(korr_den+=10));if(abs(korr_den)>99){korr_den=korr_den%10;}}
            ekran [11]=192; ekran_1_figure(((korr_den<0)?46:47),0,1);  
            line=1; /*ekran_1_figure((abs((korr_den))/100),6);*/ ekran_1_figure(((abs(korr_den)%100)/10),6,1); 
            line=0; ekran_1_figure((abs(korr_den)%10),12,1);ekran_1_figure(27,19,0);  
        break;
        case 63: //     
          
            if (BUT_OK)   {if(korr_den<0){korr_den--;if(korr_den%10==0)korr_den+=10;}else{korr_den++;if(korr_den%10==0)korr_den-=10;}}
             ekran [11]=192;ekran_1_figure(((korr_den<0)?46:47),0,1); /* ekran_1_figure((abs((korr_den))/100),6);*/ ekran_1_figure(((abs(korr_den)%100)/10),6,1); 
            line=1; ekran_1_figure((abs(korr_den)%10),12,1);ekran_1_figure(27,19,0);   line=0; 
              if (BUT_STEP) { z=0; z1=0;  t=0; temp1=0;ochistka(); meny=10;}
        break;
        }
      
//****************************************************   *******************************************        
if (flg_min)   
{
flg_min=0;        
        //_____________________ 
        for (bud_temp=0; bud_temp<9; bud_temp++)  
        {  
                if  (  
                    ( time==budilnik_time[bud_temp] )                                 //      
                &&  ( budilnik_Install[bud_temp] & 0x80)                              //      ( )
                &&  ( budilnik_Install[bud_temp] & (1 << den_nedeli) )                //           
                )                                                                                 
                bud_flg=1;                                                            //     
              
        //______________________         
                if ( time==budilnik_time[bud_temp] +  budilnik_Interval[bud_temp])    //    ""  ( 1  15 )
                {
                bud_flg=0;                                                            //    
                if (bud_temp<3)  {budilnik_Install[bud_temp] = 0;}                    //     "" ( 1-3),     
                } 
                                                                    
        }
        //______________________          
        if ( (time%60==0)&&( (time > 479) && (time < 1321) )&&(zv_chs) ) {  but_flg=1;   TIMSK|=0x10;    but_pause=0;  }    //     ( 08-00  22-00   )    
} 

if ( ((bud_flg)&&(mig))  ||  (but_flg) )   { TIMSK|=0x10;}    //     ""  1 ( . ) 
else  {PORTB.5=0; TIMSK&=0xEF;}                               


//****************************************************************************************************************************  
while (POWER == OFF )   //    ,       -  
    {
    ACSR=0x80;          //         (   )
    #asm("sleep")       // ......
    ACSR=0x4b;          //  ,  . 
    }
//****************************************************************************************************************************       
};
}
